@echo off
:: INSTALL for emTeX
:: (C) Cezary M. Kruk, ul. Zielonogorska 7 m. 2, 53-617 Wroclaw, Poland

if "%1"=="/?" goto E_0
if "%1"=="\?" goto E_1
if "%1"=="" goto E_0
if not exist %1\nul goto E_2
if "%2"=="" goto TST0
if not exist %2\nul goto E_3
if "%3"=="" goto TST0
if not exist %2\%3\nul md %2\%3
if not exist %2\%3\nul goto E_4

:TST0
if not exist ask.exe goto E_5
if not exist install.zip goto E_6
if not exist install.fil goto E_7
if not exist install.525 goto E_8
if not exist install.350 goto E_8
set dd=
set src=
set tgt=
set fil=
set dsk=
set root=
set path_bak=%path%
set path_tmp=%path%
set path_bak=
if "%path_tmp%"=="" goto E_9
if not "%path_tmp%"=="%path%" goto E_9

:TST1
if not exist c:\nul goto E_10

:TST2
path %1
set src=%path%
path %2
if not "%3"=="" set path=%path%\
set dd=%path%
path %path%%3
set tgt=%path%

:SET0
path %path_tmp%
set path_tmp=

:PATH_CMK
if exist c:\x\nul goto E_11
if exist c:\x copy c:\x c:\x.bak > nul
if exist c:\x del c:\x
echo %path%;%tgt%\emtex\binxxx>c:\x
if not exist c:\x goto E_12
del c:\x

:DEL
if not exist %tgt%\emtex goto MDR
copy %tgt%\emtex %tgt%\emtex.bak > nul
del %tgt%\emtex

:MDR
if not exist %tgt%\emtex\nul md %tgt%\emtex

:CPY
copy ask.exe %tgt%\emtex\ask.exe > nul
copy install.zip %tgt%\emtex\install.zip > nul
copy install.fil %tgt%\emtex\fil0.bat > nul
copy install.525 %tgt%\emtex\install.525 > nul
copy install.350 %tgt%\emtex\install.350 > nul
if exist install.me copy install.me %tgt%\emtex\config.me > nul

:CDR
%dd%
cd \
cd %tgt%
if not exist emtex\nul goto E_13
cd emtex

:FIL0
echo SET UZIP=%%1>fil1.bat
echo SET DVI1=%%2>> fil1.bat
echo SET DVI2=%%3>> fil1.bat
echo SET TEX0=%%4>> fil1.bat
echo SET MF=%%5>> fil1.bat
echo SET MFJ=%%6>> fil1.bat
call fil0.bat
call fil1.bat %fil%
del fil0.bat
del fil1.bat
set fil=

:SET1
set path_tmp=%path%
path %uzip%
set uzip=%path%
path %path_tmp%
set path_tmp=

:DSK0
if exist %src%\TEX_1\%uzip%.exe goto UZP
if exist %src%\%uzip%.exe goto UZP
cls
ask Prepare source drive %src%, and press `Space' when ready , ~
echo.

:UZP
if exist %src%\tex_1\%uzip%.exe %src%\tex_1\%uzip% unzip.exe
if exist %src%\%uzip%.exe %src%\%uzip% unzip.exe
if not exist unzip.exe goto E_14
unzip install > nul

:TSRC
if exist %src%tex_1\%uzip%.exe goto TTGT
if exist %src%%uzip%.exe goto TTGT
set src=%src%\

:TTGT
if exist %tgt%emtex\ask.exe goto DSK2
set tgt=%tgt%\

:DSK2
cls
echo         ARRANGING OF EMTEX ARCHIVES:
echo     ------------------------------------
echo     a.  3.5" diskettes
echo     b.  5.25" diskettes
echo     c.  in common directory on hard drive
echo.
ask Have you got emTeX archives arranged _equally_ to: ,aAbBcC
set dsk=350
if errorlevel 5 goto CFG
if errorlevel 3 set dsk=525
echo.
ask Have you got emTeX archives in subdirectories `TEX_#'? ,yYnN
echo.
if errorlevel 3 goto DSK1
set root=tex_#
echo.

:DSK1
if "dsk"=="" goto CFG
copy install.%dsk% dsk.bat > nul
call dsk.bat
del dsk.bat

:CFG
if not exist config.bat goto E_15
if exist %tgt%emtex\install.zip del %tgt%emtex\install.zip
if exist %tgt%emtex\install.fil del %tgt%emtex\install.fil
if exist %tgt%emtex\install.525 del %tgt%emtex\install.525
if exist %tgt%emtex\install.350 del %tgt%emtex\install.350
set source=%src%
set target=%tgt%
set src=
set tgt=
set uzip=
config.bat %source% %dd% %target% %dsk%

:E_0
echo Helps in installation of emTeX.
echo.
echo INSTALL source target_drive [target_directory]
echo.
echo   source             Drive and directory from which emTeX is installed.
echo   target_drive       Drive to which emTeX is installed.
echo   target_directory   Directory to which emTeX is installed.
echo.
echo   To install emTeX from `X:\FOO\FOO' to `Y:\BUZZ\BUZZ\EMTEX', type:
echo.
echo               INSTALL X:\FOO\FOO Y: BUZZ\BUZZ
echo.
goto END

:E_1
echo INSTALL 1H, Cezary M. Kruk, 1997.
goto END

:E_2
echo Invalid `%1' source specification.
goto END

:E_3
echo Invalid `%2' target specification.
goto END

:E_4
echo Unable to create `%2\%3'---made it manually.
goto END

:E_5
echo ASK.EXE not found.
goto END

:E_6
echo INSTALL.ZIP not found.
goto END

:E_7
echo INSTALL.FIL not found.
goto END

:E_8
echo INSTALL.350 or INSTALL.525 not found.
goto END

:E_9
echo Insufficient environment space or INSTALL started from some shell.
goto END

:E_10
echo Drive C: not found.
goto END

:E_11
echo Remove or rename C:\X directory.
goto END

:E_12
echo Cut PATH in your AUTOEXEC.BAT, and reset your computer.
if exist c del c
goto END

:E_13
echo INSTALL: Parameter format not correct.
goto END

:E_14
echo Source has an invalid directory structure or does not contain %uzip%.EXE.
goto END

:E_15
echo Error in INSTALL.ZIP---CONFIG.BAT not found.
goto END

:END
set dd=
set src=
set tgt=
set fil=
set dsk=
set uzip=
set mfj=
set dvi1=
set dvi2=
set tex0=
set mf=
set root=
set path_tmp=
